package sun.security.rsa;

import java.util.Iterator;
import sun.security.provider.SunEntries;
import java.util.HashMap;
import java.util.List;
import java.security.Provider;
import java.util.LinkedHashSet;

public final class SunRsaSignEntries
{
    private LinkedHashSet<Provider.Service> services;
    
    private void add(Provider provider, String type, String algorithm, String className, List<String> aliases, HashMap<String, String> attributes) {
        this.services.add(new Provider.Service(provider, type, algorithm, className, aliases, attributes));
    }
    
    public SunRsaSignEntries(Provider provider) {
        this.services = new LinkedHashSet(20, 0.9f);
        String s = "1.2.840.113549.1.1";
        List<String> aliasesWithOid = SunEntries.createAliasesWithOid(new String[] { s });
        List<String> aliasesWithOid2 = SunEntries.createAliasesWithOid(new String[] { s + ".10" });
        String s2 = "1.3.14.3.2.29";
        HashMap hashMap = new HashMap(3);
        hashMap.put("SupportedKeyClasses", "java.security.interfaces.RSAPublicKey|java.security.interfaces.RSAPrivateKey");
        this.add(provider, "KeyFactory", "RSA", "sun.security.rsa.RSAKeyFactory$Legacy", aliasesWithOid, null);
        this.add(provider, "KeyPairGenerator", "RSA", "sun.security.rsa.RSAKeyPairGenerator$Legacy", aliasesWithOid, null);
        this.add(provider, "Signature", "MD2withRSA", "sun.security.rsa.RSASignature$MD2withRSA", SunEntries.createAliasesWithOid(new String[] { s + ".2" }), hashMap);
        this.add(provider, "Signature", "MD5withRSA", "sun.security.rsa.RSASignature$MD5withRSA", SunEntries.createAliasesWithOid(new String[] { s + ".4" }), hashMap);
        this.add(provider, "Signature", "SHA1withRSA", "sun.security.rsa.RSASignature$SHA1withRSA", SunEntries.createAliasesWithOid(new String[] { s + ".5", s2 }), hashMap);
        this.add(provider, "Signature", "SHA224withRSA", "sun.security.rsa.RSASignature$SHA224withRSA", SunEntries.createAliasesWithOid(new String[] { s + ".14" }), hashMap);
        this.add(provider, "Signature", "SHA256withRSA", "sun.security.rsa.RSASignature$SHA256withRSA", SunEntries.createAliasesWithOid(new String[] { s + ".11" }), hashMap);
        this.add(provider, "Signature", "SHA384withRSA", "sun.security.rsa.RSASignature$SHA384withRSA", SunEntries.createAliasesWithOid(new String[] { s + ".12" }), hashMap);
        this.add(provider, "Signature", "SHA512withRSA", "sun.security.rsa.RSASignature$SHA512withRSA", SunEntries.createAliasesWithOid(new String[] { s + ".13" }), hashMap);
        this.add(provider, "Signature", "SHA512/224withRSA", "sun.security.rsa.RSASignature$SHA512_224withRSA", SunEntries.createAliasesWithOid(new String[] { s + ".15" }), hashMap);
        this.add(provider, "Signature", "SHA512/256withRSA", "sun.security.rsa.RSASignature$SHA512_256withRSA", SunEntries.createAliasesWithOid(new String[] { s + ".16" }), hashMap);
        this.add(provider, "KeyFactory", "RSASSA-PSS", "sun.security.rsa.RSAKeyFactory$PSS", aliasesWithOid2, null);
        this.add(provider, "KeyPairGenerator", "RSASSA-PSS", "sun.security.rsa.RSAKeyPairGenerator$PSS", aliasesWithOid2, null);
        this.add(provider, "Signature", "RSASSA-PSS", "sun.security.rsa.RSAPSSSignature", aliasesWithOid2, hashMap);
        this.add(provider, "AlgorithmParameters", "RSASSA-PSS", "sun.security.rsa.PSSParameters", aliasesWithOid2, null);
    }
    
    public Iterator<Provider.Service> iterator() {
        return this.services.iterator();
    }
}
